<?php
/**
 * 
 * Get Taxonomies
 * 
 */

function TMfeed_get_taxonomies($tax) {
    $output_terms = array('' => esc_html__( 'All', 'tmfeed' ));
    $args = array (
        'taxonomy' => array($tax),
        'hide_empty' => 1,
        'orderby' => 'name',
        'order' => 'ASC'
    );
    $terms = get_terms($args);
    if (is_array($terms)) {
        foreach($terms as $term) {
            $output_terms[$term->term_id] = $term->name;
        }
    }
    return $output_terms;
}

/**
 * 
 * Get Fonts
 * 
 */

function TMfeed_get_fonts() {
    $fonts = array(
        1 => esc_html__( 'Helvetica Neue', 'tmfeed' ),
        2 => esc_html__( 'Georgia', 'tmfeed' ),
        3 => esc_html__( 'Palatino Linotype', 'tmfeed' ),
        4 => esc_html__( 'Times New Roman', 'tmfeed' ),
        5 => esc_html__( 'Arial', 'tmfeed' ),
        6 => esc_html__( 'Arial Black', 'tmfeed' ),
        7 => esc_html__( 'Comic Sans', 'tmfeed' ),
        8 => esc_html__( 'Impact', 'tmfeed' ),
        9 => esc_html__( 'Lucida Sans', 'tmfeed' ),
        10 => esc_html__( 'Tahoma', 'tmfeed' ),
        11 => esc_html__( 'Trebuchet', 'tmfeed' ),
        12 => esc_html__( 'Verdana', 'tmfeed' ),
        13 => esc_html__( 'Courier New', 'tmfeed' ),
        14 => esc_html__( 'Lucida Console', 'tmfeed' )
    );
    return $fonts;
}

/**
 * 
 * Get Font
 * 
 */

function TMfeed_get_font($font_number) {
    $fonts = array(
        1 => '"Helvetica Neue", "Helvetica", "Arial", sans-serif',
        2 => 'Georgia, serif',
        3 => '"Palatino Linotype", "Book Antiqua", Palatino, serif',
        4 => '"Times New Roman", Times, serif',
        5 => 'Arial, Helvetica, sans-serif',
        6 => '"Arial Black", Gadget, sans-serif',
        7 => '"Comic Sans MS", cursive, sans-serif',
        8 => 'Impact, Charcoal, sans-serif',
        9 => '"Lucida Sans Unicode", "Lucida Grande", sans-serif',
        10 => 'Tahoma, Geneva, sans-serif',
        11 => '"Trebuchet MS", Helvetica, sans-serif',
        12 => 'Verdana, Geneva, sans-serif',
        13 => '"Courier New", Courier, monospace',
        14 => '"Lucida Console", Monaco, monospace'
    );
    return $fonts[$font_number];
}

/**
 * 
 * Excerpt Length
 * 
 */

function TMfeed_excerpt($post_id, $charlength) {
	$excerpt = get_the_excerpt($post_id);
	$charlength++;

	if ( mb_strlen( $excerpt ) > $charlength ) {
		$subex = mb_substr( $excerpt, 0, $charlength );
		$exwords = explode( ' ', $subex );
		$excut = - ( mb_strlen( $exwords[ count( $exwords ) - 1 ] ) );
		if ( $excut < 0 ) {
			return mb_substr( $subex, 0, $excut ) . ' ...';
		} else {
			return $subex . ' ...';
		}
	} else {
		return $excerpt;
	}
}

/**
 * 
 * Get Button Animations
 * 
 */

function TMfeed_btn_anims() {
    $output_skins = array( 
        '' => esc_html__( 'None', 'tmfeed' ),
        'tmf-btn-1' => esc_html__( 'Animation 1', 'tmfeed' ),
        'tmf-btn-2' => esc_html__( 'Animation 2', 'tmfeed' ),
        'tmf-btn-3' => esc_html__( 'Animation 3', 'tmfeed' ),
        'tmf-btn-4' => esc_html__( 'Animation 4', 'tmfeed' ),
        'tmf-btn-5' => esc_html__( 'Animation 5', 'tmfeed' ),
        'tmf-btn-6' => esc_html__( 'Animation 6', 'tmfeed' ),
        'tmf-btn-7' => esc_html__( 'Animation 7', 'tmfeed' ),
        'tmf-btn-8' => esc_html__( 'Animation 8', 'tmfeed' )   
    );
    return $output_skins;
}

/**
 * 
 * Get Image Sizes
 * 
 */

function TMfeed_get_image_sizes() {
    $output_sizes = array();
    $img_sizes = get_intermediate_image_sizes();
    $output_sizes['full'] = esc_html__( 'Full', 'tmfeed' );
    foreach ($img_sizes as $size_name) {
        $output_sizes[$size_name] = $size_name;
    }
    return $output_sizes;
}