( function( $ ) {
    "use strict";
	$( window ).on( 'elementor/frontend/init', function() {
        elementorFrontend.hooks.addAction('frontend/element_ready/tmfeed-newsticker.default', function($scope){
            // Iframe Output Update
            var iframeUpdate = function (field_id) {
                var scope_id = $scope.data('id');
                var data = $scope.data('settings');
                var iframe_height = $scope.find('.tmf-list-right').data('iframeheight');

                if (data) {
                    data[field_id] = $('#' + field_id).val();

                    var $post_tax = 0;
                    if (data.tmf_post_tax) {
                        $post_tax = data.tmf_post_tax;
                    }
                    
                    var iframe = $scope.find('#tmf-list-iframe-' + scope_id);
                    var iframe_textbox = $scope.find('#tmf-iframe-output-' + scope_id);
                    var iframe_src = iframe_textbox.data('home') + '?tmf_embed=newsticker&tmf_title=' + data.tmf_title.replace(/ /g, '%20') + '&tmf_post_tax=' + $post_tax + '&tmf_order=' + data.tmf_order + '&tmf_orderby=' + data.tmf_orderby + '&tmf_post_limit=' + data.tmf_post_limit + '&tmf_date=' + data.tmf_date + '&tmf_interval=' + data.tmf_interval + '&tmf_font_family=' + data.tmf_font_family + '&tmf_font_size=' + data.tmf_font_size + '&tmf_background=' + data.tmf_background.replace('#', '') + '&tmf_header_background=' + data.tmf_header_background.replace('#', '') + '&tmf_header_color=' + data.tmf_header_color.replace('#', '') + '&tmf_border_color=' + data.tmf_border_color.replace('#', '') + '&tmf_link_color=' + data.tmf_link_color.replace('#', '') + '&tmf_ref=' + data.tmf_ref;

                    iframe_textbox.val('<iframe loading="lazy" scrolling="no" src="' + iframe_src + '" width="100%" height="' + iframe_height + 'px" frameborder="0"></iframe>');
                    iframe.attr('src', iframe_src);
                    iframe.attr('height', iframe_height + 'px');
                }
            };

            // Colorpicker
            $scope.find('.tmf-colorpicker').spectrum({
                type: "component",
                showButtons: false,
                showAlpha: false,
                allowEmpty: false,
                showInput: true,
                preferredFormat: "hex",
                change: function() {
                    iframeUpdate($(this).attr('id'));
                }
            });

            // Numeric Validation
            $scope.find('.tmf-numeric').on('keypress', function (e) {
                if (String.fromCharCode(e.keyCode).match(/[^0-9]/g)) return false;
            });

            // Max-Min Validation
            $scope.find('.tmf-numeric').on('change', function () {
                var max = parseInt($(this).attr('max'));
                var min = parseInt($(this).attr('min'));
                if ($(this).val() > max)
                {
                   $(this).val(max);
                }
                else if ($(this).val() < min)
                {
                   $(this).val(min);
                }       
            }); 

            // Referrer Validation
            $scope.find('.tmf-ref').on('keyup', function () {
                var Text = $(this).val();
                Text = Text.toLowerCase();
                Text = Text.replace(/[^a-zA-Z0-9]+/g,'-');
                $(this).val(Text); 
            });

            // Refresh iframe after a textbox value changed
            $scope.find('.tmf-input-text').on('change', function () {
                var field_id = $(this).attr('id');
                iframeUpdate(field_id);
            });

            // Refresh iframe after a selected value changed
            $scope.find('.tmf-select').on('change', function () {
                var field_id = $(this).attr('id');
                iframeUpdate(field_id);   
            });

            // Select the code on textarea focus
            $scope.find('.tmf-textarea').on('focus', function () {
                $(this).select(); 
            });

            // Copy to clipboard button
            $scope.find('.tmf-clipboard-btn').on('click', function (e) {
                e.preventDefault();
            });
            
            var clipboard = new ClipboardJS('.tmf-clipboard-btn');

            clipboard.on('success', function(e) {
                var $default_text = $scope.find('.tmf-clipboard-btn span').text();
                $scope.find('.tmf-clipboard-btn span').text($scope.find('.tmf-clipboard-btn').data('copied'));
                setTimeout(function(){ 
                    $scope.find('.tmf-clipboard-btn span').text($default_text);
                }, 2000);
                e.clearSelection();
            });
        });        
    });
} )( jQuery );